###
### Author: Benjamin Dicken
### Description: 
###   Use this script to load amazon review files.
###   This script assumes the format is the one used in the files on this site:
###       http://jmcauley.ucsd.edu/data/amazon/
###   Each line of the file looks roughly like this:
###      {"reviewerID": "ABC", "asin": "123", "reviewerName": "something", "helpful": [0, 0], "reviewText": "look here"}
###

import json
import sqlite3
from pprint import pprint

### Establish connection with the sqlite3 database
rdb = sqlite3.connect('review.db')
### Enpty existing review table
try:
    rdb.execute('DROP TABLE review;');
except:
    print('DROP TABLE failed. Continuing . . . ')
    
### Create the review table
rdb.execute('''
  CREATE TABLE review(
    asin TEXT,
    reviewer_id TEXT, 
    review_text TEXT)''')

### Get preferred file from user
data_file = input('Path to amazon review data file: ')
### Insert all of the data into the sqltie3 table
f = open(data_file, 'r')
for line in f:
    j = json.loads(line)
    asin = j['asin']
    rid = j['reviewerID']
    review = j['reviewText'].replace('\'', '\'\'')
    query = 'INSERT INTO review VALUES(\'' + asin + '\', \'' + rid + '\', \'' + review + '\');'
    rdb.execute(query)

### Commit all of the database changes, and then close connection
rdb.commit()
rdb.close()

